<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BomRevisionSearch StructType
 * Meta information extracted from the WSDL
 * - type: listAcct:BomRevisionSearch
 * @subpackage Structs
 */
class BomRevisionSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomRevisionSearchBasic
     */
    public $basic;
    /**
     * The billOfMaterialsJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomSearchBasic
     */
    public $billOfMaterialsJoin;
    /**
     * The componentJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomRevisionComponentSearchBasic
     */
    public $componentJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $transactionJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for BomRevisionSearch
     * @uses BomRevisionSearch::setBasic()
     * @uses BomRevisionSearch::setBillOfMaterialsJoin()
     * @uses BomRevisionSearch::setComponentJoin()
     * @uses BomRevisionSearch::setTransactionJoin()
     * @uses BomRevisionSearch::setCustomSearchJoin()
     * @param \StructType\BomRevisionSearchBasic $basic
     * @param \StructType\BomSearchBasic $billOfMaterialsJoin
     * @param \StructType\BomRevisionComponentSearchBasic $componentJoin
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\BomRevisionSearchBasic $basic = null, \StructType\BomSearchBasic $billOfMaterialsJoin = null, \StructType\BomRevisionComponentSearchBasic $componentJoin = null, \StructType\TransactionSearchBasic $transactionJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setBillOfMaterialsJoin($billOfMaterialsJoin)
            ->setComponentJoin($componentJoin)
            ->setTransactionJoin($transactionJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\BomRevisionSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\BomRevisionSearchBasic $basic
     * @return \StructType\BomRevisionSearch
     */
    public function setBasic(\StructType\BomRevisionSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get billOfMaterialsJoin value
     * @return \StructType\BomSearchBasic|null
     */
    public function getBillOfMaterialsJoin()
    {
        return $this->billOfMaterialsJoin;
    }
    /**
     * Set billOfMaterialsJoin value
     * @param \StructType\BomSearchBasic $billOfMaterialsJoin
     * @return \StructType\BomRevisionSearch
     */
    public function setBillOfMaterialsJoin(\StructType\BomSearchBasic $billOfMaterialsJoin = null)
    {
        $this->billOfMaterialsJoin = $billOfMaterialsJoin;
        return $this;
    }
    /**
     * Get componentJoin value
     * @return \StructType\BomRevisionComponentSearchBasic|null
     */
    public function getComponentJoin()
    {
        return $this->componentJoin;
    }
    /**
     * Set componentJoin value
     * @param \StructType\BomRevisionComponentSearchBasic $componentJoin
     * @return \StructType\BomRevisionSearch
     */
    public function setComponentJoin(\StructType\BomRevisionComponentSearchBasic $componentJoin = null)
    {
        $this->componentJoin = $componentJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @return \StructType\BomRevisionSearch
     */
    public function setTransactionJoin(\StructType\TransactionSearchBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bomRevisionSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$bomRevisionSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($bomRevisionSearchCustomSearchJoinItem) ? get_class($bomRevisionSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($bomRevisionSearchCustomSearchJoinItem), var_export($bomRevisionSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\BomRevisionSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\BomRevisionSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
